#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#define BUFFER_SIZE 1024

#define BTCNF "pspbtcnf.txt"
#define BTCNF_VSH "pspbtcnf_vsh.txt"
#define BTCNF_GAME "pspbtcnf_game.txt"
#define BTCNF_UPDATER "pspbtcnf_updater.txt"
#define BTCNF_POPS "pspbtcnf_pops.txt"
#define BTCNF_APP "pspbtcnf_app.txt"

long fcopy(char *source, char *dest);
int main(int argc, char **argv);
int split_btcnf(char *oldfile, int single);
int build_btcnf_single(char *oldfile);
int build_btcnf_multiple(char *oldfile);

long fcopy(char *source, char *dest)
{
        FILE *d, *s;
        char *buffer;
        size_t incount;
        long totcount = 0L;

        s = fopen(source, "rb");
        if(s == NULL)
                return -1L;

        d = fopen(dest, "wb");
        if(d == NULL)
        {
                fclose(s);
                return -1L;
        }

        buffer = malloc(BUFFER_SIZE);
        if(buffer == NULL)
        {
                fclose(s);
                fclose(d);
                return -1L;
        }

        incount = fread(buffer, sizeof(char), BUFFER_SIZE, s);

        while(!feof(s))
        {
                totcount += (long)incount;
                fwrite(buffer, sizeof(char), incount, d);
                incount = fread(buffer, sizeof(char), BUFFER_SIZE, s);
        }

        totcount += (long)incount;
        fwrite(buffer, sizeof(char), incount, d);

        free(buffer);
        fclose(s);
        fclose(d);

        return totcount;
}

int main(int argc, char **argv)
{
	if(argc < 3)
//		return !printf("Usage: %s <pspbtcnf file> -build | -single | -extract | -list | -b | -s | -e | -l\n-l | -list: list the modules in the pspbtcnf file by their entry offsets\n-e | -extract: extract pspbtcnf file to pspbtcnf_*.txt\n-e -s | -extract -s: extract pspbtcnf file to pspbcnf.txt (more accurate)\n-b | -build: build pspbtcnf file from pspbtcnf_*.txt (5 files)\n-s | -single: build pspbtcnf file from pspbtcnf.txt (more accurate)\n", argv[0])-1;
		return !printf("Usage: %s <pspbtcnf file> -build | -extract -b | -e\n-e | -extract: extract pspbtcnf file to pspbcnf.txt\n-b | -build: build pspbtcnf file from pspbtcnf.txt\n", argv[0])-1;
	
//	if(strcmp(argv[2], "-build") && strcmp(argv[2], "-single") && strcmp(argv[2], "-extract") && strcmp(argv[2], "-list") && strcmp(argv[2], "-b")  && strcmp(argv[2], "-s") && strcmp(argv[2], "-e") && strcmp(argv[2], "-l"))
//		return !printf("Usage: %s <pspbtcnf file> -build | -single | -extract | -list | -b | -s | -e | -l\n-l | -list: list the modules in the pspbtcnf file by their entry offsets\n-e | -extract: extract pspbtcnf file to pspbtcnf_*.txt\n-e -s | -extract -s: extract pspbtcnf file to pspbcnf.txt (more accurate)\n-b | -build: build pspbtcnf file from pspbtcnf_*.txt (5 files)\n-s | -single: build pspbtcnf file from pspbtcnf.txt (more accurate)\n", argv[0])-1;
	if(strcmp(argv[2], "-build") && strcmp(argv[2], "-extract") && strcmp(argv[2], "-b") && strcmp(argv[2], "-e"))
		return !printf("Usage: %s <pspbtcnf file> -build | -extract -b | -e\n-e | -extract: extract pspbtcnf file to pspbcnf.txt\n-b | -build: build pspbtcnf file from pspbtcnf.txt\n", argv[0])-1;

	if(strcmp(argv[2], "-build") == 0 || strcmp(argv[2], "-b") == 0)
//		return build_btcnf_multi(argv[1]);
//	else if(strcmp(argv[2], "-single") == 0 || strcmp(argv[2], "-s") == 0)
		return build_btcnf_single(argv[1]);
	else if(strcmp(argv[2], "-extract") == 0 || strcmp(argv[2], "-e") == 0)
	{
		//if(argc == 4 && !strcmp(argv[3], "-s"))
			return split_btcnf(argv[1], 1);
		//else
			//return split_btcnf(argv[1], 0);
	}
	else
		return 0;//list_modules(argv[1]);
			
}

// FYI: This code works just fine; it's just not very useful for most people.
/*int list_modules(char *oldfile)
{
	FILE *in, *out;
	char filename[256];
	BtcnfHeader head;
	ModeEntry *modes;
	ModuleEntry module;
	in = fopen(oldfile, "r");
	u32 sig;
	fread(&sig, 4, 1, in);
	if(sig == 0x0F803000)
		return !printf("Invalid signature in input file! This pspbtcnf.bin is from an older firmware.\n")-1;
	if(sig != 0x0F803001)
		return !printf("Invalid signature in input file!\n")-1;
	fseek(in, 0, SEEK_SET);
	if(!in)
	{
		return !printf("Input file %s not found!\n", oldfile)-1;
	}

	fread(&head, sizeof(BtcnfHeader), 1, in);
	modes = (ModeEntry *)malloc(head.nmodes*sizeof(ModeEntry));
	fseek(in, head.modestart, SEEK_SET);
	int x,y;
	for(x=0;x<head.nmodules;x++)
	{
		fseek(in, head.modulestart+0x20*x, SEEK_SET);
		int offs;
		fread(&offs, sizeof(int), 1, in);
		fseek(in, head.modnamestart+offs, SEEK_SET);
		fgets(filename, 255, in);
		printf("entry at %04X is %s\n", head.modulestart+0x20*x, filename);
	}
	return;
}*/

// FYI: This code is OK, but unless single=1 it doesn't (for some reason) make a btcnf that works. I'm still figuring that part out.
int split_btcnf(char *oldfile, int single)
{
	FILE *in, *out;
	char filename[256];
	BtcnfHeader head;
	ModeEntry *modes;
	ModuleEntry module;
	in = fopen(oldfile, "r");
	if(!in)
	{
		return !printf("Input file %s not found!\n", oldfile)-1;
	}

	fread(&head, sizeof(BtcnfHeader), 1, in);
	modes = (ModeEntry *)malloc(head.nmodes*sizeof(ModeEntry));
	fseek(in, head.modestart, SEEK_SET);
	int x,y;

	printf("Loading module list... ");
	for(x = 0; x < head.nmodes; x++)
		fread(&modes[x], sizeof(ModeEntry), 1, in);
	if(single) {
		printf("done.\nWriting module list... ");
		out = fopen(BTCNF, "w");
		for(x=0;x<head.nmodules;x++)
		{
			fseek(in, head.modulestart+0x20*x, SEEK_SET);
			fread(&module, sizeof(ModuleEntry), 1, in);
			fseek(in, module.stroffset+head.modnamestart, SEEK_SET);
			fgets(filename, 255, in);
			if(module.loadmode & TYPE_DOLLAR) fputs("$", out);
			if(module.loadmode & TYPE_PERCENT) fputs("%", out);
			if(module.loadmode & TYPE_TWOPERCENT) fputs("%%", out);
			fprintf(out, "%s ", filename);

			if(module.flags & SECT_VSH)
				fprintf(out, "V");
			if(module.flags & SECT_GAME)
				fprintf(out, "G");
			if(module.flags & SECT_UPDATER)
				fprintf(out, "U");
			if(module.flags & SECT_POPS)
				fprintf(out, "P");
			if(module.flags & SECT_APP)
				fprintf(out, "A");
			fprintf(out, "\n");
		}
		printf("done.\nOutput saved as 'pspbtcnf.txt'.\n");
	} else {
		int cur_mode;
		for(x = 0; x < head.nmodes; x++)
		{
			if(modes[x].modeflag & SECT_VSH)
			{
				cur_mode = SECT_VSH;
				out = fopen(BTCNF_VSH,"w");
			}
			if(modes[x].modeflag & SECT_GAME)
			{
				cur_mode = SECT_GAME;
				out = fopen(BTCNF_GAME,"w");
			}
			if(modes[x].modeflag & SECT_UPDATER)
			{
				cur_mode = SECT_UPDATER;
				out = fopen(BTCNF_UPDATER,"w");
			}
			if(modes[x].modeflag & SECT_POPS)
			{
				cur_mode = SECT_POPS;
				out = fopen(BTCNF_POPS,"w");
			}
			if(modes[x].modeflag & SECT_APP)
			{
				cur_mode = SECT_APP;
				out = fopen(BTCNF_APP,"w");
			}

			for(y=0;y<modes[x].maxsearch;y++)
			{
				fseek(in, head.modulestart+modes[x].searchstart+0x20*y, SEEK_SET);
				fread(&module, sizeof(ModuleEntry), 1, in);
				fseek(in, module.stroffset+head.modnamestart, SEEK_SET);
				fgets(filename, 255, in);
				if(module.flags & cur_mode)
				{
					if(module.loadmode & TYPE_DOLLAR) fputs("$", out);
					if(module.loadmode & TYPE_PERCENT) fputs("%", out);
					if(module.loadmode & TYPE_TWOPERCENT) fputs("%%", out);
					fprintf(out, "%s %04X\n", filename, module.flags);
				}
			}
		}
	}
	fclose(out);
	fclose(in);
	free(modes);
	return 0;
}

int build_btcnf_single(char *oldfile)
{
	FILE *in, *out;
	in = fopen(BTCNF, "r");
	if(!in)
	{
		return !printf("Input file " BTCNF " not found!\n")-1;
	}
	char filename[256];
	char **prxfiles;

	int modules_count=0, max_modules=0;
	
	BtcnfHeader head;
	ModeEntry mode_entry;
	ModuleEntry **modules;

	char *outf = (char *)malloc(strlen(oldfile)+5);
	sprintf(outf, "%s.new", oldfile);
	fcopy(oldfile, outf);

	in = fopen(BTCNF, "r");

	int dump;
	printf("Counting modules... ");
	while(!feof(in))
	{
		memset(filename, 0, 256);

		fscanf(in, "%s %05X", filename, &dump);
		if(strlen(filename) == 0) break;
		max_modules++;
	}

	printf("done.\nLoading module list...");
	modules = (ModuleEntry **)malloc(max_modules * sizeof(ModuleEntry *));

	int module_list_length = 0;

	int len = ftell(in);
	fseek(in, 0, SEEK_SET);//fclose(in);return;

	prxfiles = (char **)malloc(max_modules * sizeof(char *));
	while(!feof(in))
	{
		int loadmode, flags;
		int j;
		char cflags[6];
		char c;
		cflags[5]='\0';
		memset(filename, 0, 256);

		char sflags[256];
		
		fscanf(in, "%s %s\n", filename, sflags);

		if(strlen(filename) == 0) break;
		flags = 0;
		for(j = 0; j < strlen(sflags); j++)
		{
			switch(sflags[j])
			{
				case 'v':
				case 'V':
					flags |= SECT_VSH;
					continue;
				case 'g':
				case 'G':
					flags |= SECT_GAME;
					continue;
				case 'u':
				case 'U':
					flags |= SECT_UPDATER;
					continue;
				case 'p':
				case 'P':
					flags |= SECT_POPS;
					continue;
				case 'a':
				case 'A':				
					flags |= SECT_APP;
					continue;
				default:
					continue;
			}
		}

		max_modules++;

		if(!strncmp(filename, "$%%", 3))
		{
			strncpy(filename, filename+3, strlen(filename)-2);
			loadmode = 0x8004;
		}
		else if(!strncmp(filename, "$%", 2))
		{
			loadmode = 0x8002;
			strncpy(filename, filename+2, strlen(filename)-1);
		}
		else if(!strncmp(filename, "$", 1))
		{
			loadmode = 0x8001;
			strncpy(filename, filename+1, strlen(filename));
		}
		else if(!strncmp(filename, "%%", 2))
		{
			loadmode = 4;
			strncpy(filename, filename+2, strlen(filename)-1);
		}
		else if(!strncmp(filename, "%", 2))
		{
			loadmode = 2;
			strncpy(filename, filename+1, strlen(filename));
		}
		else loadmode = 1;

		int i, found=0;
		for(i=0;i < modules_count; i++)
			if(!strcmp(prxfiles[i], filename))
			{
				found = 1;
				if(modules[i]->flags != flags) found = 0;
			}
		if(!found)
		{
			modules[modules_count] = (ModuleEntry *)malloc(sizeof(ModuleEntry));
			modules[modules_count]->stroffset = module_list_length;
			modules[modules_count]->loadmode = loadmode;
			modules[modules_count]->reserved = 0;
			modules[modules_count]->reserved2 = 0;
			modules[modules_count]->flags=flags;
			memset(modules[modules_count]->hash, 0, 16);

			prxfiles[modules_count] = (char *)malloc(strlen(filename)+1);
			memcpy(prxfiles[modules_count], filename, strlen(filename)+1);
			module_list_length+=strlen(filename)+1;
			modules_count++;
		}
	}

	printf("done.\nWriting output file... ");
	//printf("Found a total of %i modules; module list length = %i\n", modules_count, module_list_length);
	int i;

	out = fopen(outf, "w");
	head.signature = 0x0F803001;
	head.devkit = 0x03090010;
	head.unknown[0]=0x6B8B4567;
	head.unknown[1]=0x327B23C6;
	head.modestart=0x40;
	head.nmodes=5;
	head.unknown2[0]=0x643C9869;
	head.unknown2[1]=0x66334873;
	head.modulestart=0xE0;
	head.nmodules=modules_count;
	head.unknown3[0]=0x74B0DC51;
	head.unknown3[1]=0x19495CFF;
	head.modnamestart=head.modulestart+0x20*head.nmodules;
	head.modnameend=head.modnamestart+module_list_length;
	head.unknown4[0]=0x2AE8944A;
	head.unknown4[1]=0x625558EC;
	fwrite(&head, sizeof(head), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_VSH;
	mode_entry.mode2 = 2;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_GAME;
	mode_entry.mode2 = 1;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_UPDATER;
	mode_entry.mode2 = 3;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_POPS;
	mode_entry.mode2 = 4;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_APP;
	mode_entry.mode2 = 7;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	for(i=0; i<modules_count; i++)
	{
		if(modules[i] != NULL)
		{
			if(modules[i]->loadmode & 1)
			{
				//printf("file %i: %s loadmode: %i, stroffset: %i\n", i, prxfiles[i], modules[i]->loadmode, modules[i]->stroffset);
				fwrite(modules[i], sizeof(ModuleEntry), 1, out);
				free(modules[i]);
			}
		}
	}

	for(i=0; i<modules_count; i++)
	{
		if(modules[i] != NULL)
		{
			if(modules[i]->loadmode & 2)
			{
				//printf("file %i: %s loadmode: %i, stroffset: %i\n", i, prxfiles[i], modules[i]->loadmode, modules[i]->stroffset);
				fwrite(modules[i], sizeof(ModuleEntry), 1, out);
				free(modules[i]);
			}
		}
	}

	for(i=0; i<modules_count; i++)
	{
		if(modules[i] != NULL)
		{
			if(modules[i]->loadmode & 4)
			{
				//printf("file %i: %s loadmode: %i, stroffset: %i\n", i, prxfiles[i], modules[i]->loadmode, modules[i]->stroffset);
				fwrite(modules[i], sizeof(ModuleEntry), 1, out);
				free(modules[i]);
			}
		}
	}

	for(i=0; i<modules_count; i++)
	{
		fputs(prxfiles[i], out);
		fwrite("\0"+1, 1, 1, out);
		free(prxfiles[i]);
	}
	fclose(out);
	free(prxfiles);
	free(modules);
	printf("done.\nNew pspbtcnf file saved as '%s'.\n", outf);
	free(outf);
	return 0;	
}

// FYI: This code is OK, but it doesn't (for some reason) make a btcnf that works. I'm still figuring that part out.
/*int build_btcnf_multi(char *oldfile)
{
	FILE *in, *out;
	in = fopen(BTCNF_VSH, "r");
	if(!in)
	{
		return !printf("Input file " BTCNF_VSH " not found!\n")-1;
	}
	fclose(in);

	in = fopen(BTCNF_GAME, "r");
	if(!in)
	{
		return !printf("Input file " BTCNF_GAME " not found!\n")-1;
	}
	fclose(in);

	in = fopen(BTCNF_UPDATER, "r");
	if(!in)
	{
		return !printf("Input file " BTCNF_UPDATER " not found!\n")-1;
	}
	fclose(in);

	in = fopen(BTCNF_POPS, "r");
	if(!in)
	{
		return !printf("Input file " BTCNF_POPS " not found!\n")-1;
	}
	fclose(in);

	in = fopen(BTCNF_APP, "r");
	if(!in)
	{
		return !printf("Input file " BTCNF_APP " not found!\n")-1;
	}
	fclose(in);

	char filename[256];
	char **prxfiles;

	int modules_count=0, max_modules=0;
	
	BtcnfHeader head;
	ModeEntry mode_entry;
	ModuleEntry **modules;

	char *outf = (char *)malloc(strlen(oldfile)+5);
	sprintf(outf, "%s.new", oldfile);
	fcopy(oldfile, outf);

	in = fopen(BTCNF_VSH, "r");

	int dump;
	while(!feof(in))
	{
		memset(filename, 0, 256);
		fscanf(in, "%s %04X %04X", filename, &dump, &dump);
		if(strlen(filename) == 0) break;
		max_modules++;
	}
	fclose(in);

	in = fopen(BTCNF_GAME, "r");
	while(!feof(in))
	{
		memset(filename, 0, 256);
		fscanf(in, "%s %04X %04X", filename, &dump, &dump);
		if(strlen(filename) == 0) break;
		max_modules++;
	}
	fclose(in);

	in = fopen(BTCNF_UPDATER, "r");
	while(!feof(in))
	{
		memset(filename, 0, 256);
		fscanf(in, "%s %04X %04X", filename, &dump, &dump);
		if(strlen(filename) == 0) break;
		max_modules++;
	}
	fclose(in);

	in = fopen(BTCNF_POPS, "r");
	while(!feof(in))
	{
		memset(filename, 0, 256);
		fscanf(in, "%s %04X %04X", filename, &dump, &dump);
		if(strlen(filename) == 0) break;
		max_modules++;
	}
	fclose(in);

	in = fopen(BTCNF_APP, "r");
	while(!feof(in))
	{
		memset(filename, 0, 256);
		fscanf(in, "%s %04X %04X", filename, &dump, &dump);
		if(strlen(filename) == 0) break;
		max_modules++;
	}
	fclose(in);

	prxfiles = (char **)malloc(max_modules * sizeof(char *));
	modules = (ModuleEntry **)malloc(max_modules * sizeof(ModuleEntry *));

	int module_list_length = 0;

	in = fopen(BTCNF_VSH, "r");

	while(!feof(in))
	{
		int loadmode;
		memset(filename, 0, 256);
		fscanf(in, "%s %04X", filename, &loadmode);
		if(strlen(filename) == 0) break;
		max_modules++;

		if(!strncmp(filename, "$%%", 3))
			strncpy(filename, filename+3, strlen(filename)-2);
		if(!strncmp(filename, "%%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$", 1))
			strncpy(filename, filename+1, strlen(filename));

		int i, found=0;
		for(i=0;i < modules_count; i++)
			if(!strcmp(prxfiles[i], filename))
			{
				found = 1;
				modules[i]->flags |= SECT_VSH;
			}
		//if(!found)
		//{
			modules[modules_count] = (ModuleEntry *)malloc(sizeof(ModuleEntry));
			modules[modules_count]->stroffset = module_list_length;
			modules[modules_count]->loadmode = loadmode;
			modules[modules_count]->reserved = 0;
			modules[modules_count]->reserved2 = 0;
			modules[modules_count]->flags=SECT_VSH;
			memset(modules[modules_count]->hash, 0, 16);

			prxfiles[modules_count] = (char *)malloc(strlen(filename)+1);
			memcpy(prxfiles[modules_count], filename, strlen(filename)+1);
			module_list_length+=strlen(filename)+1;
			modules_count++;
		//}
	}

	in = fopen(BTCNF_GAME, "r");

	while(!feof(in))
	{
		int loadmode;
		memset(filename, 0, 256);
		fscanf(in, "%s %04X", filename, &loadmode);
		if(strlen(filename) == 0) break;
		max_modules++;

		if(!strncmp(filename, "$%%", 3))
			strncpy(filename, filename+3, strlen(filename)-2);
		if(!strncmp(filename, "%%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$", 1))
			strncpy(filename, filename+1, strlen(filename));

		int i, found=0;
		for(i=0;i < modules_count; i++)
			if(!strcmp(prxfiles[i], filename))
			{
				found = 1;
				modules[i]->flags |= SECT_GAME;
			}

		//if(!found)
		//{
			modules[modules_count] = (ModuleEntry *)malloc(sizeof(ModuleEntry));
			modules[modules_count]->stroffset = module_list_length;
			modules[modules_count]->loadmode = loadmode;
			modules[modules_count]->reserved = 0;
			modules[modules_count]->reserved2 = 0;
			modules[modules_count]->flags=SECT_GAME;
			memset(modules[modules_count]->hash, 0, 16);

			prxfiles[modules_count] = (char *)malloc(strlen(filename)+1);
			memcpy(prxfiles[modules_count], filename, strlen(filename)+1);
			module_list_length+=strlen(filename)+1;
			modules_count++;
		//}
	}

	in = fopen(BTCNF_UPDATER, "r");

	while(!feof(in))
	{
		int loadmode;
		memset(filename, 0, 256);
		fscanf(in, "%s %04X", filename, &loadmode);
		if(strlen(filename) == 0) break;
		max_modules++;

		if(!strncmp(filename, "$%%", 3))
			strncpy(filename, filename+3, strlen(filename)-2);
		if(!strncmp(filename, "%%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$", 1))
			strncpy(filename, filename+1, strlen(filename));

		int i, found=0;
		for(i=0;i < modules_count; i++)
			if(!strcmp(prxfiles[i], filename))
			{
				found = 1;
				modules[i]->flags |= SECT_UPDATER;
			}
		//if(!found)
		//{
			modules[modules_count] = (ModuleEntry *)malloc(sizeof(ModuleEntry));
			modules[modules_count]->stroffset = module_list_length;
			modules[modules_count]->loadmode = loadmode;
			modules[modules_count]->reserved = 0;
			modules[modules_count]->reserved2 = 0;
			modules[modules_count]->flags=SECT_UPDATER;
			memset(modules[modules_count]->hash, 0, 16);

			prxfiles[modules_count] = (char *)malloc(strlen(filename)+1);
			memcpy(prxfiles[modules_count], filename, strlen(filename)+1);
			module_list_length+=strlen(filename)+1;
			modules_count++;
		//}
	}

	in = fopen(BTCNF_POPS, "r");

	while(!feof(in))
	{
		int loadmode;
		memset(filename, 0, 256);
		fscanf(in, "%s %04X", filename, &loadmode);
		if(strlen(filename) == 0) break;
		max_modules++;

		if(!strncmp(filename, "$%%", 3))
			strncpy(filename, filename+3, strlen(filename)-2);
		if(!strncmp(filename, "%%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$", 1))
			strncpy(filename, filename+1, strlen(filename));

		int i, found=0;
		for(i=0;i < modules_count; i++)
			if(!strcmp(prxfiles[i], filename))
			{
				found = 1;
				modules[i]->flags |= SECT_POPS;
			}
		//if(!found)
		//{
			modules[modules_count] = (ModuleEntry *)malloc(sizeof(ModuleEntry));
			modules[modules_count]->stroffset = module_list_length;
			modules[modules_count]->loadmode = loadmode;
			modules[modules_count]->reserved = 0;
			modules[modules_count]->reserved2 = 0;
			modules[modules_count]->flags=SECT_POPS;
			memset(modules[modules_count]->hash, 0, 16);

			prxfiles[modules_count] = (char *)malloc(strlen(filename)+1);
			memcpy(prxfiles[modules_count], filename, strlen(filename)+1);
			module_list_length+=strlen(filename)+1;
			modules_count++;
		//}
	}

	in = fopen(BTCNF_APP, "r");

	while(!feof(in))
	{
		int loadmode;
		memset(filename, 0, 256);
		fscanf(in, "%s %04X", filename, &loadmode);
		if(strlen(filename) == 0) break;
		max_modules++;

		if(!strncmp(filename, "$%%", 3))
			strncpy(filename, filename+3, strlen(filename)-2);
		if(!strncmp(filename, "%%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$%", 2))
			strncpy(filename, filename+2, strlen(filename)-1);
		if(!strncmp(filename, "$", 1))
			strncpy(filename, filename+1, strlen(filename));

		int i, found=0;
		for(i=0;i < modules_count; i++)
			if(!strcmp(prxfiles[i], filename))
			{
				found = 1;
				modules[i]->flags |= SECT_APP;
			}

		//if(!found)
		//{
			modules[modules_count] = (ModuleEntry *)malloc(sizeof(ModuleEntry));
			modules[modules_count]->stroffset = module_list_length;
			modules[modules_count]->loadmode = loadmode;
			modules[modules_count]->reserved = 0;
			modules[modules_count]->reserved2 = 0;
			modules[modules_count]->flags=SECT_APP;
			memset(modules[modules_count]->hash, 0, 16);

			prxfiles[modules_count] = (char *)malloc(strlen(filename)+1);
			memcpy(prxfiles[modules_count], filename, strlen(filename)+1);
			module_list_length+=strlen(filename)+1;
			modules_count++;
		//}
	}

	printf("Found a total of %i modules; module list length = %i\n", modules_count, module_list_length);
	int i;
	for(i=0;i<modules_count;i++)

	out = fopen(outf, "w");
	head.signature = 0x0F803001;
	head.devkit = 0x03090010;
	head.unknown[0]=0x6B8B4567;
	head.unknown[1]=0x327B23C6;
	head.modestart=0x40;
	head.nmodes=5;
	head.unknown2[0]=0x643C9869;
	head.unknown2[1]=0x66334873;
	head.modulestart=0xE0;
	head.nmodules=modules_count;
	head.unknown3[0]=0x74B0DC51;
	head.unknown3[1]=0x19495CFF;
	head.modnamestart=head.modulestart+0x20*head.nmodules;
	head.modnameend=head.modnamestart+module_list_length;
	head.unknown4[0]=0x2AE8944A;
	head.unknown4[1]=0x625558EC;
	fwrite(&head, sizeof(head), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_VSH;
	mode_entry.mode2 = 2;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_GAME;
	mode_entry.mode2 = 1;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_UPDATER;
	mode_entry.mode2 = 3;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_POPS;
	mode_entry.mode2 = 4;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	mode_entry.maxsearch=modules_count;
	mode_entry.searchstart=0;
	mode_entry.modeflag = SECT_APP;
	mode_entry.mode2 = 7;
	memset(mode_entry.reserved, 0, 5*sizeof(int));
	fwrite(&mode_entry, sizeof(ModeEntry), 1, out);

	for(i=0; i<modules_count; i++)
	{
		if(modules[i] != NULL)
		{
			if(modules[i]->loadmode & 1)
			{
				printf("file %i: %s loadmode: %i, stroffset: %i\n", i, prxfiles[i], modules[i]->loadmode, modules[i]->stroffset);
				fwrite(modules[i], sizeof(ModuleEntry), 1, out);
				free(modules[i]);
			}
		}
	}

	for(i=0; i<modules_count; i++)
	{
		if(modules[i] != NULL)
		{
			if(modules[i]->loadmode & 2)
			{
				printf("file %i: %s loadmode: %i, stroffset: %i\n", i, prxfiles[i], modules[i]->loadmode, modules[i]->stroffset);
				fwrite(modules[i], sizeof(ModuleEntry), 1, out);
				free(modules[i]);
			}
		}
	}

	for(i=0; i<modules_count; i++)
	{
		if(modules[i] != NULL)
		{
			if(modules[i]->loadmode & 4)
			{
				printf("file %i: %s loadmode: %i, stroffset: %i\n", i, prxfiles[i], modules[i]->loadmode, modules[i]->stroffset);
				fwrite(modules[i], sizeof(ModuleEntry), 1, out);
				free(modules[i]);
			}
		}
	}

	for(i=0; i<modules_count; i++)
	{
		fputs(prxfiles[i], out);
		fwrite("\0"+1, 1, 1, out);
		free(prxfiles[i]);
	}
	fclose(out);
	free(outf);
	free(prxfiles);
	free(modules);
	return 0;	
}
*/
