#define u8 unsigned char
#define u16 unsigned short
#define u32 unsigned int

enum {
	SECT_VSH = 1,
	SECT_GAME = 2,
	SECT_UPDATER = 4,
	SECT_POPS = 8,
	SECT_LICENSE = 0x10,
	SECT_APP = 0x40
} section_flags;

enum {
	TYPE_SECT = 0,
	TYPE_NOPERCENT = 1,
	TYPE_PERCENT = 2,
	TYPE_TWOPERCENT = 4,
	TYPE_DOLLAR = 0x8000
} prx_listing_types;

typedef struct BtcnfHeader
{
	int signature; // 0
	int devkit; // 4
	int unknown[2]; // 8
	int modestart; // 0x10
	int nmodes; // 0x14
	int unknown2[2]; // 0x18
	int modulestart; // 0x20
	int nmodules; // 0x24
	int unknown3[2]; // 0x28
	int modnamestart; // 0x30
	int modnameend; // 0x34
	int unknown4[2]; // 0x38
} __attribute__((packed)) BtcnfHeader;

typedef struct ModeEntry
{
	u16 maxsearch;
	u16 searchstart; //
	int modeflag;
	int mode2;
	int reserved[5];
} __attribute__((packed)) ModeEntry;

typedef struct ModuleEntry
{
	u32 stroffset;
	int reserved;
	u16 flags;
	u16 loadmode;
	int reserved2;
	u8 hash[0x10];
} __attribute__((packed)) ModuleEntry;
